
/*
 * =====================================================================================
 *        Class:  GFRD
 *  Description:  
 * =====================================================================================
 */
using namespace utils;
class GFRD
{
  private:
  gsl_rng*     rand_gen;
  VexT u;         //unit vector
  VexT z_axis;
  exT dist;       //dist beatween points
  VexT r;
  VexT R;
  VexT R_0;
  VexT r_0;
  exT theta,phi;    
  public:


  
  GFRD ();  /* constructor */

  protected:


}; /* -----  end of class  GFRD  ----- */

GFRD::GFRD ()
{
}  /* -----  end of method GFRD::GFRD  (constructor)  ----- */

VexT vec_rotation(const VexT& v,const exT& theta,const exT& phi)
  {
    VexT V(3);
    double x0=sin(theta),x2=sin(phi),
           x1=cos(theta),x3=cos(phi);
    V[0]=v[0]*x3+(v[1]*x1+v[2]*x0)*x2;
    V[1]=-v[0]*x2+(v[1]*x1+v[2]*x0)*x3;
    V[2]=-v[1]*x0+v[2]*x1;
    return V;
  }
void calculate_position(const VexT& r_0,const exT& theta,const exT& phi,const exT& r,VexT& r_fin)
{
  z_axis[0]=0.0;z_axis[1]=0.0;z_axis[2]=1.0; //z_axis
  u=r_0;
  dist=sqrt(vec_sq_norm<3>(u));
  u=u/dist;   //unit vector
  sqmat<3> transf=target_rotator<3>(u,z_axis); //Hauseholder matrix
  r_fin=transf.trans()*vec_rotation(z_axis,theta,phi); //vector after transformation 
  r_fin=r_fin*r;
} 
////FREE DIFFUSION
//D --- sum of diffusion constants
//t --- time of the jump
void free_diffuse(D,t)
{
  double square_root; //sqrt(2Dt)---variance
  square_root=sqrt(2.0*D*t);
  //new positions
  for(unsigned i=0; i<3; ++i) R[i]=R_0[i]+square_root*gsl_ran_ugaussian(rand_gen);  
}    
////MUST BE DEFINED
//s_db_ov_da=sqrt(D_B/D_A)
//s_da_ov_db=sqrt(D_A/D_B)
//s_da_mp_db=sqrt(D_A*D_B)
//D =(D_A+D_B)
void get_R_0(const VexT& r_A,const VexT& r_B)
  {
    R_0=r_A*s_db_ov_da+r_B*s_da_ov_db;
  }
void get_r_0(const VexT& r_A,const VexT& r_B,VexT& r_0)
  {
    r_0=r_B-r_A;
  }
//position of the complex A...B after reaction
void position_after_reaction(const VexT& r_A,const VexT& r_B)
  {
    r=1.0/(D)*((R-R_0)*s_da_mp_db+r_A*D_B+r_B*D_A);        
  }
void calc_R()
  {

  }
void calc_r()
  {

  }
void get_r(VexT& r_A,VexT& r_B)
  {
    r_A=(1.0/(D))*(R*s_da_mp_db-r*D_A);
    r_B=r+r_A;
  }
