
/*
 * =====================================================================================
 *        Class:  diff_reaction
 *  Description:  
 * =====================================================================================
 */
class diff_reaction
{
  public:
  bool uni;                      //the same species
  bool r_c_0;                    //if the rate constant is 0
   
  size_t group1;                  //diff reaction beetwen particles from groups 
  size_t group2;                  // 
  
  double react_rate_const;       //k
  double int_react_rate_const;   //k 
  double D;                      //sum of diffusion constants
  double r;                      //sum of radii
  
  double s_db_ov_da;             //sq(B/A)
  double s_da_ov_db;             //sq(A/B)
  double s_da_mp_db;             //sq(A*B)
     
  diff_reaction(size_t g1, size_t g2, double D_a, double D_b, double r_a, double r_b, double i_k);  /* constructor */
  diff_reaction(size_t g1, double D_a, double r_a);  /* constructor */
  private:

}; /* -----  end of class  diff_reactions  ----- */
/*
 *--------------------------------------------------------------------------------------
 *       Class:  diff_reaction
 *      Method:  diff_reaction
 * Description:  constructor
 *--------------------------------------------------------------------------------------
 */
diff_reaction::diff_reaction (size_t g1, size_t g2, double D_a, double D_b, double r_a, double r_b, double i_k)
             :group1(g1),group2(g2),D(D_a+D_b),r(r_a+r_b),react_rate_const(i_k),
              s_da_mp_db(sqrt(D_a*D_b)),s_da_ov_db(sqrt(D_a/D_b)),s_db_ov_da(sqrt(D_b/D_a))
{
  uni=false;
  if(i_k==0.0) {r_c_0=true;} else{r_c_0=false;}
}  /* -----  end of method diff_reaction::diff_reaction  (constructor)  ----- */
diff_reaction::diff_reaction(size_t g1, double D_a, double r_a)
             :group1(g1),group2(g1),D(D_a+D_a),r(r_a+r_a),int_react_rate_const(0.0)
{
  uni=true;
  r_c_0=true;
} 



  
