#include "root.cpp"
#include "0dimensional.cpp"
#include "simulation.cpp"
#include "maple.cpp"

int main(int argc, char* argv[])
  {
    //input file
    string  input(argv[1]);

    //simulation directory
    string sim_dir(argv[2]);
  
    file_management f_m;
    string cwd;
    f_m.get_current_work_dir(cwd);
    if(!sim_dir.empty())
    {
      sim_dir=cwd+sim_dir+"/";
    }
    else
    {
     sim_dir=cwd;
    }
    string::size_type pos,pos1;
    pos=input.find_last_of("/")+1;
    pos1=input.find_last_of(".");
    //logs
    string file_name(input,pos,pos1-pos);
    string logs(sim_dir+file_name+".log");
    
    int err=mkdir(sim_dir.c_str(),0755);
    string first_comm;
    if(err!=0) 
    {
      first_comm=sim_dir+" :"+strerror(errno)+"\n";
    }
    system(("cp "+input+" "+sim_dir).c_str());     //keep info about input  
    ofstream output_stream(logs.c_str(),ios::trunc);
    output_stream.setf(ios::showpoint);
    f_m.output=&output_stream;
    if(!first_comm.empty())
    {
       output_stream<<first_comm;
    }


       
  string check(argv[3]);
  write_host_pid_curr_program my_host_pid(check);

    
  double  infi=INFINITY;
    
   
//seed initiatization
    unsigned long int seed = time(NULL);
   // unsigned long int seed = 1299696874;
//rng initialization          
    gsl_rng * rand_gen ;
    rand_gen= gsl_rng_alloc (gsl_rng_mt19937);
    gsl_rng_set (rand_gen, seed);
//write seed    
    ofstream write_seed((sim_dir+"seed").c_str(),ios::trunc);
    write_seed.setf(ios::showpoint);
    write_seed<<seed;
    write_seed.close();

//simulation
    root             info(rand_gen,input,sim_dir,f_m);
      
    simulation       sim(info,rand_gen);
 
//maple input
    maple            m(info,sim_dir);
    m.write_input_for_maple();
   
    
    
    output_stream.close();
    my_host_pid.write_finish();

    
    
    
   }
