/****************************************************************************************
***********************************SPECIFICATION*****************************************	
Calculation of moments
*****************************************************************************************
****************************************************************************************/	
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <stdio.h>
#include <cstdlib>
#include <unistd.h>
#include <string.h>
#include <cassert>
#include <iomanip>
#include <cmath>
#include <limits.h>

#include <vector>
#include <valarray>
#include <stack>
#include <list>
#include <queue>
#include <algorithm>
#include <iostream>
#include <string.h>
#include <iomanip>
#include <string>
#include <sstream>
#include <fstream>
#include <cmath>
#include <cassert>
#include <vector>
using namespace std;
/****************************************************************************************
***********************************DECLARATIONS*****************************************/	

string itos(int i, unsigned field_length=5);

void parse_line(const string& str, vector<string>& tokens, const string& delimiters = " ");

int line_counting(const string& file_name);

void table_with_zeros(const int number_elements, double table[]);

void prepare_table_with_mean_variance
     (const string& where_to_write, const string& what_to_write,
		 	const int how_data_sets, 
			double mean[], double variance[],
			const int what_line_rewrite, const int what_line_mean);
//inline bool isnan(double value)
//  {
//    return value != value;
//  }
/*****************************************************************************************
*************************************MAIN************************************************/
int main(int argc, char* argv[])
{
assert(argc>5);
int how_data_sets=atoi(argv[1]);
int what_line_rewrite=atoi(argv[2])-1;
int what_line_mean=atoi(argv[3])-1;
string where_to_write(argv[4]);
string what_to_write(argv[5]);
const int c_linecounter=line_counting(where_to_write+what_to_write+"/00000"); 
double sum[c_linecounter];      
double product[c_linecounter];  
table_with_zeros(c_linecounter,sum);
table_with_zeros(c_linecounter,product);
prepare_table_with_mean_variance
(where_to_write, what_to_write, how_data_sets, sum, product,what_line_rewrite, what_line_mean);
}
/*****************************************************************************************
********************************FUNCTIONS************************************************/	
void parse_line(const string& str, vector<string>& tokens, const string& delimiters)
   {
   // Skip delimiters at beginning.
   string::size_type lastPos = str.find_first_not_of(delimiters, 0);
   // Find first "non-delimiter".
   string::size_type pos = str.find_first_of(delimiters, lastPos);
   while (string::npos != pos || string::npos != lastPos)
      {
      // Found a token, add it to the vector.
      tokens.push_back(str.substr(lastPos, pos - lastPos));
      assert(tokens.back().size()>0);
      // Skip delimiters.  Note the "not_of"
      lastPos = str.find_first_not_of(delimiters, pos);
      // Find next "non-delimiter"
      pos = str.find_first_of(delimiters, lastPos);
      }
   }
string itos(int i, unsigned field_length)
   {
   ostringstream oss;
   oss << setfill('0') << setw(field_length) << i;
   return oss.str();
   }
int line_counting(const string& what_to_write)
{
int linecounter=0;	
string s;
ifstream we(what_to_write.c_str());
if(!we) {cerr<<"Error: file not found - "<<what_to_write<<endl; exit(1);}
while( getline(we,s) )
     {
       ++linecounter;
     }
we.close(); 
return linecounter;
}
//Zeruje tablice
void table_with_zeros(const int number_elements, double table[])
{
for ( int i=0 ; i<number_elements ; i++ )
{
  table[i]=0.0;
}
}
void prepare_table_with_mean_variance
     (const string& where_to_write, const string& what_to_write,
			const int how_data_sets, 
			double mean[], double variance[],
			const int what_line_rewrite, const int what_line_mean)
{
vector<string> line;  
int line_means;       
int linecounter=0;
string file_name;
string s;
for(int i=0;i<how_data_sets;i++)
   {
     ifstream read;                
     file_name=itos(i);            
     cout<<file_name<<char(13)<<flush;        
     file_name=where_to_write+what_to_write+"/"+file_name;
     read.open(file_name.c_str()); //
     if(!read) {cerr<<"Error: file not found - "<<file_name<<endl; exit(1);}
     linecounter=0;
     while( getline(read,s) )
     {
       parse_line(s, line);
       line_means=atoi((line[what_line_mean]).c_str());
       mean[linecounter]+=double(line_means);
       variance[linecounter]+=double(line_means)*double(line_means);
       ++linecounter;
       line.clear();
     }
     read.close();
   }
cout<<endl;
for ( int i=0; i<linecounter ; i++ )
{
   mean[i]/=double(how_data_sets);
   variance[i]=variance[i]/double(how_data_sets)-mean[i]*mean[i];
}
{
ofstream write((where_to_write+what_to_write+"_mean.dat").c_str(),ios::trunc);
write.setf(ios::showpoint);
ifstream read;
read.open((where_to_write+what_to_write+"/00000").c_str());
if(!read) {cerr<<"Error: file not found - "<<"file"<<endl; exit(1);}

linecounter=0;
write<<"# 1-time,2-mean,3-st.dev.,4-mean+3*st.dev,5-mean-3*st.dev,6-cv,7-Fano_factor"<<endl;
while( getline(read,s) )
     {
       parse_line(s, line);
       if(!isnan((variance[linecounter])/mean[linecounter]))
       {
         write<<line[what_line_rewrite]<<" "<<mean[linecounter]<<" "
              <<sqrt(variance[linecounter])<<" ";
         write<<mean[linecounter]+3.0*sqrt(variance[linecounter])<<" "
              <<mean[linecounter]-3.0*sqrt(variance[linecounter])<<" ";
         write<<sqrt(variance[linecounter])/mean[linecounter]<<" ";
         write<<variance[linecounter]/mean[linecounter];
         write<<"\n";
       }
       ++linecounter;
       line.clear();
     }
read.close();
write.close();
}
}	
